#ifndef F_CPU
#warning "F_CPU war noch nicht definiert, wird nun mit 8000000 definiert"
#define F_CPU 8000000UL     /* Quarz mit 8 Mhz  */
#endif

#include <avr/io.h>
#include <util/delay.h> 

#include "uart.h"
#include "PortBits.h"
#include "adc.h"

static uint8_t keyPressed(void)
{
	uint8_t i, mask, x;

	x = PINB;
	mask = 1;
	for (i = 0; i <= 13; i += 2) {
		if (6 == i)
			i--;
		if (13 == i)
			i--;
		if ((x & mask) == 0)
			return i + 60;
		mask <<= 1;
	}
	return 0;
}

uint8_t SendChar(uint8_t byte) {
	uart_putc(byte);
	uint8_t temp=0xff;
	int cnt=0;
	while (temp == 0xff) {
		temp = 	uart_getc_nowait();
		cnt++;
		_delay_ms(1);
		if (cnt >= 100) {
			return 0; //timeout
		}
	}
		if (temp == byte) return 1; //alles ok
		else if (temp != 255) return 0; //Wenn empfangenes nicht das abgesende ist, aber etwas im Buffer liegt ist die übertragung fehlgeschlagen!
}

uint8_t SendCode(uint8_t byte1,uint8_t byte2,uint8_t byte3,uint8_t byte4) {	
	if (SendChar(254)) { //reset
		if (SendChar(byte1)) {
			if (SendChar(byte2)) {
				if (SendChar(byte3)) {
					if (SendChar(byte4)) return 1;
				}
			}
		}
	}
	return 0;
}

int main(void) {
_delay_ms(1000); //Wait for the CPU to boot
	uart_init(19600);
	DDRB=0x0; 	//eingang
	PORTB=0xff;	//pullups an
	
	/*uint8_t key, lastKey = 0;
	uint8_t keyDidChange = 0;*/

	int nADC[6];
	int oADC[6];
	while (1) {
/*while (1) {
while (!SendCode(0x0b,0xb0,78,100));
_delay_ms(500);
}*/
		/* Since no keys are connected ignore the following lines :) */
		/* key = keyPressed();
		if (lastKey != key) keyDidChange = 1;

		if (keyDidChange) {
			if (lastKey) {	// release
				while (!SendCode(0x08,0x80,lastKey,0x00));
			}
			if (key) {	// press
				while (!SendCode(0x09,0x90,lastKey,0xff));
			}
			keyDidChange = 0;
			lastKey = key;

		}*/
		uint8_t i;
		for (i=1; i < 6; i++) {			
			nADC[i] = readADC(i);
			if (nADC[i] > oADC[i]+7 || nADC[i] < oADC[i] -7) {
				//Send data
				while (!SendCode(0x0b,0xb0,78+i,nADC[i] >> 3)); 
				oADC[i] = nADC[i];
				_delay_ms(1);
			}
		}

	}
	return 0;
}





