/*
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS"
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

Author: C_Classic (cclassicvideos@aol.com)
  Date: 01.10.2010
*/

#include "uart.h"
#include <string.h>
//#define BAUDRATE 38400UL //Definition als unsigned long, sonst gibt es Fehler in der Berechnung

void uart_init(unsigned long BAUDRATE)
{
    PORTD |= (1 << PD0); //RX_pullup
    uint16_t ubrr = (uint16_t) ((uint32_t) F_CPU/(16*BAUDRATE) - 1);

    UART_UBRRH = (uint8_t) (ubrr>>8);
    UART_UBRRL = (uint8_t) (ubrr);

    // UART Receiver und Transmitter anschalten
    // Data mode 8N1, asynchron
    UART_UCSRB = (1 << UART_RXEN) | (1 << UART_TXEN);
#ifdef UART_URSEL
    UART_UCSRC = (1 << UART_URSEL) | (1 << UART_UCSZ1) | (1 << UART_UCSZ0);
#else
    //UART_UCSRC = (1 << UART_UCSZ1) | (1 << UART_UCSZ0) | (1 << UART_USBS);
    UART_UCSRC = (1 << UART_UCSZ1) | (1 << UART_UCSZ0);
#endif

    // Flush Receive-Buffer (entfernen evtl. vorhandener ungültiger Werte)
    do
    {
        UART_UDR;
    }
    while (UART_UCSRA & (1 << UART_RXC));
}

//Sends the text over the RS232-Port.
void uart_sendtext(char *text) {
int x;
        for (x=0; x < strlen(text); x++) {
                uart_putc (text[x]);
        }
}
//Sends the text over the RS232-Port with CRLF at th end.
void uart_sendtextNL(char *text) {
int x;
        for (x=0; x < strlen(text); x++) {
                uart_putc (text[x]);
        }
        uart_putc (13); //CR
        uart_putc (10); //LF
}
