#ifndef UART_H_
#define UART_H_ UART_H_ 	//!< protects this file from beeing double included

#define m32 0
#define m644 1

//SETTINGS:
    #define MCU m32
//SETTINGS END


#if MCU == m32
    #define UART_UCSRA UCSRA
    #define UART_UDRE UDRE
    #define UART_UDR UDR
    #define UART_RXC RXC
    #define UART_UCSRB UCSRB
    #define UART_UCSRC UCSRC
    #define UART_RXEN RXEN
    #define UART_TXEN TXEN
    #define UART_URSEL URSEL
    #define UART_UCSZ0 UCSZ0
    #define UART_UCSZ1 UCSZ1
    #define UART_UBRRL UBRRL
    #define UART_UBRRH UBRRH
    #define UART_USBS USBS
#elif MCU == m644
    #define UART_UCSRA UCSR0A
    #define UART_UDRE UDRE0
    #define UART_UDR UDR0
    #define UART_RXC RXC0
    #define UART_UCSRB UCSR0B
    #define UART_UCSRC UCSR0C
    #define UART_RXEN RXEN0
    #define UART_TXEN TXEN0
    //#define UART_URSEL ""
    #define UART_UCSZ0 UCSZ00
    #define UART_UCSZ1 UCSZ01
    #define UART_UBRRL UBRR0L
    #define UART_UBRRH UBRR0H
    #define UART_USBS USBS0
#else
        #warning -----------------------------------------------
        #warning SERIAL DRIVER DOES NOT SUPPORT THIS CONTROLLER!
        #warning -----------------------------------------------
#endif

        #include <avr/io.h>

        extern void uart_init(unsigned long BAUDRATE);

	static inline int
	uart_putc (const uint8_t c)
	{
            // Warten, bis UART_UDR bereit ist für einen neuen Wert
            while (!(UART_UCSRA & (1 << UART_UDRE)))
		;

            // UART_UDR Schreiben startet die Übertragung
            UART_UDR = c;

	    return 1;
	}

	static inline uint8_t
	uart_getc_wait(void)
	{
	    // Warten, bis etwas empfangen wird 
            while (!(UART_UCSRA & (1 << UART_RXC)))
		;

	    // Das empfangene Zeichen zurückliefern 
            return UART_UDR;
	}

	static inline int
	uart_getc_nowait(void)
	{
	    // Liefer das empfangene Zeichen, falls etwas empfangen wurde; -1 sonst 
            return (UART_UCSRA & (1 << UART_RXC)) ? (int) UART_UDR : -1;
	}
void uart_sendtext(char *text);
void uart_sendtextNL(char *text);


#endif

